#include <Servo.h>

Servo motor;

int schalterGestellPin = A1;
int schalterHebebObenPin = A2;
int schalterHebebUntenPin = A3;
int motorEN_Pin = A4;
int motorA1_Pin = 2;
int motorB1_Pin = 3;
int motorPWM_Pin = 4;
int servoPin = 6;

int motorGeschwinigkeit = 0;

int motorRichtung = 0; //Wert 0 = motor dreht sich nicht, Wert 1 = rechtsdrehend, Wert 2 = linksdrehend


void setup() {
  Serial.begin (9600);
  motor.attach (servoPin);
  motor.write (125);
  pinMode (schalterGestellPin, INPUT);
  pinMode (schalterHebebObenPin, INPUT);
  pinMode (schalterHebebUntenPin, INPUT);
  pinMode (motorEN_Pin, OUTPUT);
  pinMode (motorA1_Pin, OUTPUT);
  pinMode (motorB1_Pin, OUTPUT);
  pinMode (motorPWM_Pin, OUTPUT);
}

void loop() {
  /* Serial.print ("Gestell: ");
    Serial.println(analogRead (schalterGestellPin));
    Serial.print ("Oben: ");
    Serial.println(analogRead (schalterHebebObenPin));
    Serial.print ("Unten: ");
    Serial.println(analogRead (schalterHebebUntenPin));

    delay (400);*/
  motorGeschwinigkeit = 0;
  if (analogRead (schalterHebebUntenPin) > 1020) {
    motorRichtung = 1;
    motorGeschwinigkeit = 0;
  }
  if (analogRead (schalterGestellPin) > 1020) {
    motorGeschwinigkeit = 75;
  }
  else {
    motorGeschwinigkeit = 0;
  }
  if (analogRead (schalterHebebObenPin) > 1020) {
    motorRichtung = 2;
    motorGeschwinigkeit = 0;
    motorDrehen(motorRichtung, motorGeschwinigkeit);
    servoKippen (125, 80, 3);
    motorGeschwinigkeit = 75;
  }

  motorDrehen(motorRichtung, motorGeschwinigkeit);

  Serial.println(motorRichtung);
  Serial.println(motorGeschwinigkeit);
  delay (20);
}

void motorDrehen(int richtung, int pwm) {



  if (richtung == 1) {
    digitalWrite (motorA1_Pin, LOW);
    digitalWrite (motorB1_Pin, HIGH);
  }
  if (richtung == 2) {
    digitalWrite (motorA1_Pin, HIGH);
    digitalWrite (motorB1_Pin, LOW);
  }
  if ((richtung != 1) && (richtung != 2)) {
    digitalWrite (motorA1_Pin, LOW);
    digitalWrite (motorB1_Pin, LOW);
  }
  analogWrite (motorPWM_Pin, pwm);
}

void servoKippen(int startWinkel, int endWinkel, int wiederholungen) {
  for (int i = 0; i <= wiederholungen; i++) {
    for (int j = startWinkel; j >= endWinkel; j--) {
      motor.write (j);
      delay (20);
    }
    for (int k = endWinkel; k <= startWinkel; k++) {
      motor.write (k);
      delay (5);
    }
    delay (200);
  }
}
