#include <IRremote.h> //Version 2.2.3
//IR Empfaenger
  int IRpin = 2;
  IRrecv IRreceiver(IRpin); //für die IR Übertragung
  decode_results IRwert;  
  //Ultraschallsensor
  int pingPin = 4;
  int echoPin = 3;
  
  void onSignal() {   
  long duration, cm;
  pinMode(pingPin, OUTPUT);
  digitalWrite(pingPin, LOW);
  delayMicroseconds(2);
  digitalWrite(pingPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(pingPin, LOW);
  pinMode(echoPin, INPUT);
  duration = pulseIn(echoPin, HIGH);
  cm = microsecondsToCentimeters(duration);
  Serial.print(cm);
  Serial.print("cm");
  Serial.println();
}


void setup() {
  Serial.begin(9600);
  //IR Empfaenger
  pinMode(IRpin, INPUT);
  IRreceiver.enableIRIn();
  
  pinMode(pingPin, OUTPUT);
  pinMode(13, OUTPUT);
  attachInterrupt(digitalPinToInterrupt(2), onSignal, RISING);
}
 
void loop() {
  
}
 
long microsecondsToCentimeters(long microseconds) {
  return microseconds / 29 / 2;
}
